
(defun EARX:LIST-LAY (/)

  (setq EARX_LIST nil)                  ; Alte Datenliste lschen
  (setq EARX_DAT (tblnext "LAYER" T))   ;Solange noch Eintrge
  (while EARX_DAT
    (setq EARX_NAM (cdr (assoc 2 EARX_DAT)))
    (setq EARX_LIST (cons EARX_NAM EARX_LIST))
    (setq EARX_DAT (tblnext "LAYER"))
    ) ;_ end of while
  ) ;_ end of defun

(defun DXF (A)
  (cdr (assoc A (entget ONE)))
  ) ;_ end of defun

(defun COMPLEX ()
  (while (not (wcmatch (DXF 0) "*END*"))
    (setq ONE  (entnext ONE)
          ELEM (append ELEM (list ONE))
          ) ;_ end of setq
    (CHECK)
    ) ;_ end of while
  ) ;_ end of defun

(defun CORECT (A)
  (cond
    ((= (type (cdr A)) 'list)
     (cons (car A)
           (mapcar '(lambda (X) (atof (rtos X 2 8))) (cdr A))
           ) ;_ end of cons
     )
    ((equal (type (cdr A)) 'REAL)
     (cons (car A)
           (car
             (mapcar '(lambda (X) (atof (rtos X 2 8))) (list (cdr A)))
             ) ;_ end of car
           ) ;_ end of cons
     )
    (t A)
    ) ;_ end of cond
  ) ;_ end of defun

(defun CHECK ()
  (foreach X (entget ONE)
    (if (and
          (not (member (car X) '(-2 -1 5 6 48 60 100 330 360)))
          (or (/= (car X) 2)
              (/= (cdr (assoc 0 (entget ONE))) "DIMENSION")
              ) ;_ end of or
          ) ;_ end of and
      (setq TEMP (cons (CORECT X) TEMP))
      ) ;_ end of if
    ) ;_ end of foreach
  ) ;_ end of defun

(defun revelem (el        /         tt        pktwertli ffwertli
                rdz       ugalist   ffwertlist          tmpfflist
                pktwert   ffwert    uwert     neuwert   wert
                tmpz      y         tmplist   wdhz      uglist
                plleer    kosys     anzkpn    kplistf   EL_TMP
                )
  (cond
    ((= (cdr (assoc 0 el)) "LINE")
     (setq EL_TMP (nth 1 el))
     (setq el
            (subst
              (cons 11 (cdr (nth 2 el)))
              (nth 1 el)
              el
              ) ;_ end of subst
           ) ;_ end of setq
     (entmod el)
     (setq el
            (subst
              (cons 10 (cdr EL_TMP))
              (nth 2 el)
              el
              ) ;_ end of subst
           ) ;_ end of setq
     (entmod el)
     (setq TEMP el)
     )
    ((= (cdr (assoc 0 el)) "LWPOLYLINE")
     (setq el (reverse el))
     (setq tmplist (member (assoc 10 el) el))
     (setq tmplist (reverse tmplist))
     (setq tmplist (member (assoc 42 tmplist) tmplist))
     (setq tmplist (reverse tmplist))
     (setq plkpli tmplist)
     (setq lenli (length plkpli))
     (setq wdhz 0)
     (repeat (/ lenli 4)
       (setq zuslist (list
                       (nth (* 4 wdhz) plkpli)
                       (nth (+ 1 (* 4 wdhz)) plkpli)
                       (nth (+ 2 (* 4 wdhz)) plkpli)
                       (nth (+ 3 (* 4 wdhz)) plkpli)
                       ) ;_ end of list
             ) ;_ end of setq
       (setq wdhz (1+ wdhz))
       (if (= uglist nil)
         (setq uglist (list zuslist))
         (setq uglist (append uglist (list zuslist)))
         ) ;_ end of if
       ) ;_ end of repeat
     (foreach elem uglist
       (setq pktwert (assoc 10 elem))
       (setq ffwert (member (assoc 40 elem) elem))
       (if (= ffwertli nil)
         (setq ffwertli (list ffwert))
         (setq ffwertli (append ffwertli (list ffwert)))
         ) ;_ end of if
       (if (= pktwertli nil)
         (setq pktwertli (list pktwert))
         (setq pktwertli (append pktwertli (list pktwert)))
         ) ;_ end of if
       ) ;_ end of foreach
     (setq pktwertli (reverse pktwertli))
     (foreach wert ffwertli
       (setq uwert (nth 2 wert))
       (setq neuwert (cons 42 (* -1 (cdr uwert)))) ;vorher(cadr uwert)
       (setq ffwert (subst neuwert (assoc 42 wert) wert))
       (if (= ffwertlist nil)
         (setq ffwertlist (list ffwert))
         (setq ffwertlist (append ffwertlist (list ffwert)))
         ) ;_ end of if
       ) ;_ end of foreach
     (setq ffwertlist
            (append
              ffwertlist
              (list
                (list (cons 40 0.0) (cons 41 0.0) (cons 42 0.0))
                ) ;_ end of list
              ) ;_ end of append
           ) ;_ end of setq
     (setq ffwertli ffwertlist)
     (setq rdz 0)
     (foreach selpkt pktwertli
       (if (= ugalist nil)
         (setq ugalist (list (append (list selpkt) (nth rdz ffwertli))))
         (setq
           ugalist (append
                     ugalist
                     (list (append (list selpkt) (nth rdz ffwertli)))
                     ) ;_ end of append
           ) ;_ end of setq
         ) ;_ end of if
       (setq rdz (1+ rdz))
       ) ;_ end of foreach
     (setq kpliste ugalist)
     (foreach pkt kpliste
       (if (= kplistf nil)
         (setq kplistf
                (list (car pkt) (cadr pkt) (caddr pkt) (cadddr pkt))
               ) ;_ end of setq
         (setq kplistf (append kplistf
                               (list (car pkt)
                                     (cadr pkt)
                                     (caddr pkt)
                                     (cadddr pkt)
                                     ) ;_ end of list
                               ) ;_ end of append
               ) ;_ end of setq
         ) ;_ end of if
       ) ;_ end of foreach
     (setq plleer el)
     (setq kosys (assoc 210 plleer))
     (setq anzkpn (cons 90 (/ (length kplistf) 4)))
     (setq
       plleer (reverse
                (member (assoc 39 (reverse plleer)) (reverse plleer))
                ) ;_ end of reverse
       ) ;_ end of setq
     (setq nlineli (append plleer kplistf (list kosys)))
     (setq nlineli (subst anzkpn (assoc 90 nlineli) nlineli))
     (setq el (reverse nlineli))
     )
    ) ;_ end of cond
  ) ;_ end of defun

(defun myerror (s)                      ; If an error (such as CTRL-C) occurs
                                        ; while this command is active...
  (if (/= s "Funktion abgebrochen")
    (princ (strcat "\nFehler: " s))
    ) ;_ end of if
  (setvar "cmdecho" CM)                 ; Restore saved modes
  (setq *error* olderr)                 ; Restore old *error* handler
  (princ)
  ) ;_ end of defun

(defun C:DOPPELT (/ CM LISTA NEW ONE TEMP OLD M:ROTOR)
  (setq OLDERR  *ERROR*
        *ERROR* MYERROR
        CM      (getvar "cmdecho")
        LISTA   NIL
        Lay     NIL
        lacount NIL
        NEW     NIL
        aslay   NIL
        ONE     NIL
        TEMP    NIL
        wasmach NIL
        OLD     (ssget "_X")
        ) ;_ end of setq
  (setvar "cmdecho" 0)
  (initget "S L")
  (EARX:LIST-LAY)
  (setq wasmach
         (getkword
           "Doppelte Elemente auf <S>eperaten Layer legen oder <L>schen ?"
           ) ;_ end of getkword
        ) ;_ end of setq
  (command "_-layer" "_u" "*" "")
  (prompt "\Bearbeite Zeichnung ")
  (if (> (sslength OLD) 250)
    (prompt "\nBitte warten... \n")
    ) ;_ end of if
  (cond
    ((= wasmach "L")
     (setq MD_ZAEHLER 0)
     (while
       (> (length EARX_LIST) MD_ZAEHLER)
        (if (setq ASLAY
                   (ssget "X" (list (cons 8 (nth MD_ZAEHLER EARX_LIST))))
                  ) ;_ end of setq
          (progn
            (setq ELEM_ZAEHL 0)
            (while
              (> (sslength ASLAY) ELEM_ZAEHL)
               (setq ONE (ssname ASLAY ELEM_ZAEHL))
               (setq ELEM (append ELEM (list ONE)))
               (CHECK)
               (if (or (and (= (DXF 0) "INSERT") (= (DXF 66) 1))
                       (= (DXF 0) "POLYLINE")
                       ) ;_ end of or
                 (COMPLEX)
                 ) ;_ end of if
               (cond
                 ((member TEMP LISTA)
                  (foreach X ELEM (entdel x))
                  ) ;_ end of if
                 ((and (/= LISTA nil) (= (cdr (assoc 0 TEMP)) "LINE"))
                  (revelem TEMP)
                  (if
                    (member TEMP LISTA)
                     (foreach X ELEM (entdel x))
                     ) ;_ end of if
                  )
                 ((and (/= LISTA nil)
                       (= (cdr (assoc 0 TEMP)) "LWPOLYLINE")
                       ) ;_ end of and
                  (revelem TEMP)
                  (if
                    (member TEMP LISTA)
                     (foreach X ELEM (entdel x))
                     ) ;_ end of if
                  )
                 ) ;_ end of cond
               (setq LISTA (cons TEMP LISTA)
                     TEMP  NIL
                     ELEM  NIL
                     ) ;_ end of setq
               (cond
                 (M:ROTOR (setq M:ROTOR NIL) (princ "\r\\"))
                 (t (setq M:ROTOR (princ "\r/")))
                 ) ;_ end of cond
               (setq ELEM_ZAEHL (1+ ELEM_ZAEHL))
               ) ;_ end of while
            ) ;_ end of progn
          ) ;_ end of if
        (setq LISTA NIL)
        (setq MD_ZAEHLER (1+ MD_ZAEHLER))
        ) ;_ end of while
;;;     (prompt (strcat "\nElemente vor Bereinigung- "
;;;                     (itoa (sslength OLD))
;;;                     ) ;_ end of strcat
;;;             ) ;_ end of prompt
;;;     (prompt (strcat "\nElemente nach Bereinigung - "
;;;                     (itoa (sslength (ssget
;;;                                       "_X"
;;;                                       ) ;_ end of ssget
;;;                                     ) ;_ end of sslength
;;;                           ) ;_ end of itoa
;;;                     ) ;_ end of strcat
;;;             ) ;_ end of prompt
     (prompt
       (strcat "\nEs wurden "
               (itoa (- (sslength OLD) (sslength (ssget "_X"))))
               " Elemente gelscht!"
               ) ;_ end of strcat
       ) ;_ end of prompt
     )
    ((= wasmach "S")
     (setq MD_ZAEHLER 0)
     (setq oldlay (getvar "clayer"))
     (if (not (tblsearch "layer" "doppelt"))
       (progn
         (setq ladopp "doppelt")
         (command "_.Layer" "mach" "doppelt" "ltyp" "continuous" "" "") ;_ end of command
         ) ;_ end of progn
       (Progn
         (setq ladopp "doppelt_000")
         (command "_.Layer" "mach" "doppelt_000" "ltyp" "continuous" ""
                  "") ;_ end of command
         ) ;_ end of Progn
       ) ;_ end of if
     (while
       (> (length EARX_LIST) MD_ZAEHLER)
        (if (setq ASLAY
                   (ssget "X" (list (cons 8 (nth MD_ZAEHLER EARX_LIST))))
                  ) ;_ end of setq
          (progn
            (setq ELEM_ZAEHL 0)
            (while
              (> (sslength ASLAY) ELEM_ZAEHL)
               (setq ONE (ssname ASLAY ELEM_ZAEHL))
               (setq ELEM (append ELEM (list ONE)))
               (CHECK)
               (if (or (and (= (DXF 0) "INSERT") (= (DXF 66) 1))
                       (= (DXF 0) "POLYLINE")
                       ) ;_ end of or
                 (COMPLEX)
                 ) ;_ end of if
               (cond
                 ((member TEMP LISTA)
                  (foreach X ELEM
                    (entmod
                      (subst (cons 8 ladopp)
                             (assoc 8 (entget x))
                             (entget x)
                             ) ;_ end of subst
                      ) ;_ end of entmod
                    ) ;_ end of foreach
                  )
                 ((and (/= LISTA nil) (= (cdr (assoc 0 TEMP)) "LINE"))
                  (revelem TEMP)
                  (if
                    (member TEMP LISTA)
                     (foreach X ELEM
                       (entmod
                         (subst (cons 8 ladopp)
                                (assoc 8 (entget x))
                                (entget x)
                                ) ;_ end of subst
                         ) ;_ end of entmod
                       ) ;_ end of foreach
                     ) ;_ end of if
                  )
                 ((and (/= LISTA nil)
                       (= (cdr (assoc 0 TEMP)) "LWPOLYLINE")
                       ) ;_ end of and
                  (revelem TEMP)
                  (if
                    (member TEMP LISTA)
                     (foreach X ELEM
                       (entmod
                         (subst (cons 8 ladopp)
                                (assoc 8 (entget x))
                                (entget x)
                                ) ;_ end of subst
                         ) ;_ end of entmod
                       ) ;_ end of foreach
                     ) ;_ end of if
                  )
                 ) ;_ end of cond
               (setq LISTA (cons TEMP LISTA)
                     TEMP  NIL
                     ELEM  NIL
                     ) ;_ end of setq
               (cond
                 (M:ROTOR (setq M:ROTOR NIL) (princ "\r\\"))
                 (t (setq M:ROTOR (princ "\r/")))
                 ) ;_ end of cond
               (setq ELEM_ZAEHL (1+ ELEM_ZAEHL))
               ) ;_ end of while
            ) ;_ end of progn
          ) ;_ end of if
        (setq LISTA NIL)
        (setq MD_ZAEHLER (1+ MD_ZAEHLER))
        ) ;_ end of while
     (if (ssget
           "_X"
           (list (cons 8 ladopp))
           ) ;_ end of ssget
       (prompt
         (strcat "\nEs wurden "
                 (itoa (- (sslength OLD)
                          (sslength (ssget "_X" (list (cons 8 ladopp))))
                          ) ;_ end of -
                       ) ;_ end of itoa
                 " Elemente gendert!"
                 ) ;_ end of strcat
         ) ;_ end of prompt
       (progn
         (setvar "clayer" oldlay)
         (command "_.purge" "_la" ladopp "n")
         (prompt
           (strcat "\nEs wurden keine Doppelten Elemente gefunden!"
                   ) ;_ end of strcat
           ) ;_ end of prompt
         ) ;_ end of progn
       ) ;_ end of if
     )
    ) ;_ end of cond
  (setvar "cmdecho" CM)
  (princ)
  ) ;_ end of defun
(prompt "\nStarten mit DOPPELT.\n")
(princ)
;|Visual LISP Format Options
(72 2 40 1 T "end of " 60 9 0 0 0 nil T nil T)
;*** KEINEN Text unterhalb des Kommentars hinzufgen! ***|;
